version: "3"
services:
  postgres:
    image: postgres:13
    environment:
      - "POSTGRES_PASSWORD=meercat"
      - "POSTGRES_USER=gitlab"
      - "POSTGRES_DB=gitlabhq_production"
    volumes:
      - ./dev/postgres/initdb:/docker-entrypoint-initdb.d
  redis:
    image: redis:6.0.10
    command: ["redis-server", "/usr/local/etc/redis/redis.conf"]
    volumes:
      - ./dev/redis:/usr/local/etc/redis
  migrations:
    image: ${GITLAB_RAILS_IMAGE}
    environment:
      - "CONFIG_TEMPLATE_DIRECTORY=/var/opt/gitlab/config/templates"
      - "CONFIG_DIRECTORY=/srv/gitlab/config"
      - "BYPASS_SCHEMA_VERSION=true"
      - "GITLAB_SHARED_RUNNERS_REGISTRATION_TOKEN=runnertestsecretregtoken"
      - "ENABLE_BOOTSNAP=true"
      - "BOOTSNAP_LOG=1"
    command: ["/scripts/wait-for-deps", "/scripts/db-migrate"]
    depends_on:
      - postgres
      - redis
    volumes:
      - ./dev/webservice-config:/var/opt/gitlab/config/templates
      - ./dev/shell-secret:/var/opt/gitlab/config/secrets
      - db-upgrade:/var/opt/gitlab/.upgrade-status
  webservice:
    image: ${GITLAB_WEBSERVICE_IMAGE}
    environment:
      - "WAIT_FOR_TIMEOUT=${WAIT_FOR_TIMEOUT}"
      - "GITLAB_WEBSERVER=PUMA"
      - "GITLAB_HOST=localhost"
      - "GITLAB_PORT=${HOST_PORT}"
      - "GITLAB_SSH_PORT=${SSH_HOST_PORT}"
      - "GITALY_FEATURE_DEFAULT_ON=1"
      - "CONFIG_TEMPLATE_DIRECTORY=/var/opt/gitlab/config/templates"
      - "CONFIG_DIRECTORY=/srv/gitlab/config"
      - "ACTION_CABLE_IN_APP=true"
      - "REGISTRY_PORT=${REGISTRY_PORT}"
      - "KAS_INTERNAL_API_PORT=${KAS_INTERNAL_API_PORT}"
      - "KAS_EXTERNAL_API_PORT=${KAS_EXTERNAL_API_PORT}"
      - "KAS_KUBERNETES_API_PORT=${KAS_KUBERNETES_API_PORT}"
      - "prometheus_multiproc_dir=/metrics"
      - "ENABLE_BOOTSNAP=true"
      - "BOOTSNAP_LOG=1"
    command: ["/scripts/wait-for-deps", "/scripts/process-wrapper"]
    depends_on:
      - postgres
      - redis
    ports:
      - "${WEBSERVICE_HOST_PORT}:8080"
    volumes:
      - ./dev/webservice-config:/var/opt/gitlab/config/templates
      - ./dev/shell-secret:/var/opt/gitlab/config/secrets
      - ./dev/workhorse-config/.gitlab_workhorse_secret:/srv/gitlab/.gitlab_workhorse_secret
      - ./dev/pages-secret/.gitlab_pages_secret:/srv/gitlab/.gitlab_pages_secret
      - ./dev/gitlab-kas/.gitlab_kas_internal_api_secret:/srv/gitlab/.gitlab_kas_secret
      - uploads:/srv/gitlab/public/uploads
      - shared-dir:/srv/gitlab/shared
      - pages:/srv/gitlab/shared/pages
      - ./dev/registry/gitlab-registry.key:/etc/gitlab/registry/gitlab-registry.key
      - metrics-dir:/metrics
  workhorse:
    image: ${GITLAB_WORKHORSE_IMAGE}
    environment:
      - "CONFIG_TEMPLATE_DIRECTORY=/var/opt/gitlab/config/templates"
      - "CONFIG_DIRECTORY=/srv/gitlab/config"
      - "GITLAB_WORKHORSE_EXTRA_ARGS=-authBackend http://webservice:8080 -cableBackend http://webservice:8080"
    command: ["/scripts/start-workhorse"]
    depends_on:
      - webservice
      - redis
    ports:
      - "${WORKHORSE_HOST_PORT}:8181"
      - "${HOST_PORT}:8181"
    volumes:
      - ./dev/workhorse-config:/var/opt/gitlab/config/templates
      - ./dev/workhorse-config/.gitlab_workhorse_secret:/etc/gitlab/gitlab-workhorse/secret
      - uploads:/srv/gitlab/public/uploads
      - shared-dir:/srv/gitlab/shared
      - pages:/srv/gitlab/shared/pages
  sidekiq:
    image: ${GITLAB_SIDEKIQ_IMAGE}
    command: ["/scripts/wait-for-deps", "/scripts/process-wrapper"]
    depends_on:
      - postgres
      - redis
    environment:
      - "WAIT_FOR_TIMEOUT=${WAIT_FOR_TIMEOUT}"
      - "GITLAB_HOST=localhost"
      - "GITLAB_PORT=${HOST_PORT}"
      - "GITALY_FEATURE_DEFAULT_ON=1"
      - "CONFIG_TEMPLATE_DIRECTORY=/var/opt/gitlab/config/templates"
      - "CONFIG_DIRECTORY=/srv/gitlab/config"
      - "ENABLE_BOOTSNAP=true"
      - "BOOTSNAP_LOG=1"
    volumes:
      - ./dev/sidekiq-config:/var/opt/gitlab/config/templates
      - uploads:/srv/gitlab/public/uploads
      - shared-dir:/srv/gitlab/shared
      - pages:/srv/gitlab/shared/pages
  shell:
    image: ${GITLAB_SHELL_IMAGE}
    environment:
      - "CONFIG_TEMPLATE_DIRECTORY=/srv/gitlab-config"
      - "CONFIG_DIRECTORY=/srv/gitlab-shell"
    ports:
      - "${SSH_HOST_PORT}:2222"
    volumes:
      - ./dev/shell-config:/srv/gitlab-config
      - ./dev/shell-secret:/srv/gitlab-secrets
  gitaly:
    image: ${GITLAB_GITALY_IMAGE}
    ports:
      - "${GITALY_HOST_PORT}:8075"
    volumes:
      - ./dev/gitaly-config:/etc/gitaly
  pages:
    image: ${GITLAB_PAGES_IMAGE}
    command: "/scripts/start-pages"
    depends_on:
      - webservice
    ports:
      - "${PAGES_HOST_PORT}:8090"
    environment:
      - "CONFIG_TEMPLATE_DIRECTORY=/etc/gitlab-pages/templates"
      - "CONFIG_DIRECTORY=/etc/gitlab-pages"
      - "PAGES_CONFIG_FILE=/etc/gitlab-pages/pages-config"
    volumes:
      - ./dev/pages-config/pages-config.tpl:/etc/gitlab-pages/templates/pages-config.tpl
      - ./dev/pages-secret/.gitlab_pages_secret:/etc/gitlab-pages/.gitlab_pages_secret
      - shared-dir:/srv/gitlab/shared
      - pages:/srv/gitlab/shared/pages
  registry_migrations:
    image: ${GITLAB_REGISTRY_IMAGE}
    command: ["/scripts/wait-for-deps", "/scripts/db-migrate"]
    environment:
      - "BYPASS_SCHEMA_VERSION=1"
    depends_on:
      - postgres
    volumes:
      - ./dev/registry/config.yml:/etc/docker/registry/config.yml
      - ./dev/registry/gitlab-registry.crt:/etc/docker/registry/gitlab-registry.crt
  registry:
    image: ${GITLAB_REGISTRY_IMAGE}
    command: ["/scripts/wait-for-deps", "/scripts/process-wrapper"]
    depends_on:
      - registry_migrations
    ports:
      - "${REGISTRY_PORT}:5000"
    environment:
      - "REGISTRY_AUTH_TOKEN_REALM='http://localhost:${HOST_PORT}/jwt/auth'"
    volumes:
      - ./dev/registry/config.yml:/etc/docker/registry/config.yml
      - ./dev/registry/gitlab-registry.crt:/etc/docker/registry/gitlab-registry.crt
      - registry-storage:/var/lib/registry/docker/
  kas:
    image: ${GITLAB_KAS_IMAGE}
    command: ["--configuration-file=/etc/kas/config.yml"]
    depends_on:
      - redis
    ports:
      - "${KAS_EXTERNAL_API_PORT}:8150"
      - "${KAS_INTERNAL_API_PORT}:8153"
      - "${KAS_KUBERNETES_API_PORT}:8154"
      - "${KAS_PRIVATE_API_PORT}:8155"
    environment:
      - "OWN_PRIVATE_API_URL=grpc://kas:8155"
    volumes:
      - ./dev/gitlab-kas/config.yml:/etc/kas/config.yml
      - ./dev/gitlab-kas/.gitlab_kas_internal_api_secret:/etc/kas/.gitlab_kas_internal_api_secret
      - ./dev/gitlab-kas/.gitlab_kas_private_api_secret:/etc/kas/.gitlab_kas_private_api_secret
      - ./dev/gitlab-kas/.redis_password:/etc/kas/.redis_password
  runner:
    image: ${GITLAB_RUNNER_IMAGE}
    depends_on:
      - webservice
    entrypoint: "/register-and-run"
    environment:
      - "REGISTRATION_TOKEN=runnertestsecretregtoken"
      - "CI_SERVER_URL=http://workhorse:8181/"
      - "CLONE_URL=http://workhorse:8181/"
      - "RUNNER_EXECUTOR=shell"
    volumes:
    - ./dev/runner/register-and-run:/register-and-run
  zoekt_indexer:
    image: ${GITLAB_ZOEKT_INDEXER_IMAGE}
    ports:
      - "${ZOEKT_INDEXER_PORT}:6065"
    volumes:
      - zoekt-index:/data/index
  zoekt_webserver:
    image: ${GITLAB_ZOEKT_WEBSERVER_IMAGE}
    ports:
      - "${ZOEKT_WEBSERVER_PORT}:6070"
    volumes:
      - zoekt-index:/data/index
volumes:
  db-upgrade:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=10M"
  uploads:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=100M"
  pages:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=100M"
  shared-dir:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=100M"
  registry-storage:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
  metrics-dir:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=20M"
  zoekt-index:
    driver: local
    driver_opts:
      type: tmpfs
      device: tmpfs
      o: "size=50M"
